LeetCode题解(Week 5) 452. Minimum Number of Arrows to Burst Balloons

原题目

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it’s horizontal, y-coordinates don’t matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Example:

Input: [[10,16], [2,8], [1,6], [7,12]]

Output: 2

Explanation: One way is to shoot one arrow for example at x = 6
(bursting the balloons [2,8] and [1,6]) and another arrow at x = 11
(bursting the other two balloons).

中文大意

给定N个气球的坐标范围[start,end],当一支箭穿过这个一个气球所在的区间的时候,可以射穿这个气球。求可以射穿所有气球所需的最少箭。

题解

class Solution {
public:
    int findMinArrowShots(vector<pair<int, int>>& points) {

        if(points.empty()) return 0;
        int res = 1;
        priority_queue<pair<int,int>,vector<pair<int,int> >, greater<pair<int,int> > > q;
        //按照起始位置(start)进行排序
        for(int i = 0 ; i < points.size(); i ++)
            q.push(points[i]);

        int start = q.top().first;
        int end = q.top().second;
        q.pop();
        while(!q.empty())
        {
            if(end < q.top().first)
            {
                res++;
                start = q.top().first;
                end = q.top().second;
            }
            else
            {
                start = max(start,q.top().first);
                end = min(end,q.top().second);
            }
            q.pop();
        }
        return res;
    }
};

解题思路

实际上这道题需要做的是求若干个区间的交集。对于求交集的个过程,可以通过贪心算法来解决:

  1. 建立优先队列,每一个区间的起始位置越小,具有的优先级越高
  2. 将所有的区间放入队列中
  3. 用两个变量表示当前的交集区间,遍历建立好的优先队列:每次取出一个元素,用这个元素来更新当前的交集区间
  4. 更新的过程如下:求当前区间与当前交集区间的交集,如果没有交集,则需要的箭数目+1,并将当前区间赋值给当前交集区间

在不考虑建队时间的情况下,算法的时间复杂度为O(n),空间复杂度为O(n)

心得体会

该题再次印证了优先队列十分适用于贪心算法

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值